<script setup lang="ts">
  const slots = useSlots();
  const props = defineProps<{
    modelValue?: boolean;
    errors?: any[];
  }>();

  const emit = defineEmits(['update:modelValue']);

  const checked = computed({
    get: () => {
      return props.modelValue;
    },
    set: (newValue) => {
      emit('update:modelValue', newValue);
    },
  });
</script>

<template>
  <label class="inline-flex items-start">
    <input
      v-model="checked"
      type="checkbox"
      :class="[
        'border-border peer h-5 w-5 cursor-pointer rounded text-emerald-700 shadow transition focus:ring-emerald-700 disabled:cursor-not-allowed disabled:shadow-none',
        checked
          ? 'hover:text-emerald-700 active:text-emerald-900 disabled:bg-emerald-100 disabled:hover:bg-emerald-100 disabled:active:bg-emerald-100'
          : 'hover:bg-interactive-hover active:bg-interactive-pressed disabled:bg-background-raised disabled:active:bg-background-raised',
        errors?.length && 'border-crimson-500',
      ]"
      v-bind="$attrs"
    />
    <div class="flex flex-col pl-2">
      <SwLabel v-if="slots.label" as="span" class="text-sm/6">
        <slot name="label"></slot>
      </SwLabel>
      <span v-if="slots.meta" class="text-(information-subdued xs) font-medium">
        <slot name="meta"></slot>
      </span>
    </div>
  </label>
</template>
